VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsBacteria"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private abacBacterias As New clsBacteria
Private colBaterias As New Collection

Private lngColumnas As Long
Private lngFilas As Long

Private lngColumna As Long
Private lngFila As Long

Private blnCreada As Boolean
Private blnViva As Boolean

Event Nacimiento(Columna As Long, Fila As Long)
Event Muerte(Columna As Long, Fila As Long)

Public Sub Crear(Columnas As Long, Filas As Long)

If blnCreada Then Destruir

lngColumnas = Columnas
lngFilas = Filas

ReDim abacBacterias(1 To lngColumnas, 1 To lngFilas)

Dim i As Long, j As Long
For j = 1 To lngFilas
    For i = 1 To lngColumnas
        abacBacterias(i, j).Crear i, j
        colBacterias.Add abacBaterias(i, j)
    Next i
Next j
blnCreada = True

End Sub

'Por qu este procedimiento es privado si el anterior
'era pblico

Private Sub Destruir()

    Dim bac As clsBacteria
    For Each bac In colBacterias
        Set bac = Nothing
    Next bac
    
End Sub

'Probar a quitar esta funcion para ver si funciona el For each
Public Function NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"

    Set NewEnum = colBacterias.[_NewEnum]

End Function
Property Get Viva() As Boolean
    
    Viva = blnViva
    
End Property

Property Get Columnas() As Long
    
    Columnas = lngColumnas
    
End Property

Property Get Filas() As Long
    
    Filas = lngFilas
    
End Property
Property Get Columna() As Long
    
    Columna = lngColumna
    
End Property

Property Get Fila() As Long
    
    Fila = lngFila
    
End Property

Property Get Bacterias(Columna As Long, Fila As Long) As clsBacteria
    
    If Columna < 1 Or Columna > lngColumnas Or Fila < 1 Or Fila > lngFilas Then
    
        Set Bateria = Nothing
        
    Else
        Set bacteria = abacBacterias(Columna, Fila)
    End If
    
End Property

Property Get Creada() As Boolean
    
    Creada = blnCreada
    
End Property
Function Nacer()

    Nacer = False
    If Not blnCreada Then Exit Function
    blnViva = True
    RaiseEvent Nacimiento(lngFila, lngColumna)
    Nacer = True
    
End Function
Function Morir()

    Morir = False
    If Not blnCreada Then Exit Function
    blnViva = False
    RaiseEvent Muerte(lngFila, lngColumna)
    Morir = True
    
End Function

Function Procrear() As Boolean

On Error GoTo Error

Procrear = False

If Not blnCreada Then Exit Function

'Dim ablnBacterias() As Boolean
Dim ablnBacterias(1 To lngColumnas, 1 To lngFilas) As Boolean

Dim i As Long, j As Long
Dim lngVecinas As Long

For j = 1 To lngFilas
    For i = 1 To lngColumnas
    
        lngVecinas = 0
        
        If abacBacterias(i - 1, j - 1).Viva Then
            lngVecinas = lngVecinas + 1
        End If
        If abacBacterias(i - 0, j - 1).Viva Then
            lngVecinas = lngVecinas + 1
        End If
        If abacBacterias(i + 1, j - 1).Viva Then
            lngVecinas = lngVecinas + 1
        End If
        If abacBacterias(i - 1, j - 0).Viva Then
            lngVecinas = lngVecinas + 1
        End If
        If abacBacterias(i + 1, j - 0).Viva Then
            lngVecinas = lngVecinas + 1
        End If
        If abacBacterias(i - 1, j + 1).Viva Then
            lngVecinas = lngVecinas + 1
        End If
        If abacBacterias(i - 0, j + 1).Viva Then
            lngVecinas = lngVecinas + 1
        End If
        If abacBacterias(i + 1, j + 1).Viva Then
            lngVecinas = lngVecinas + 1
        End If
        
        Select Case lngVecinas
            Case 2
                ablnBacterias(i, j) = abacBacterias(i, j).Viva
            Case 3
                ablnBacterias(i, j) = True
            Case Else
                ablnBacterias(i, j) = False
        End Select
        
    Next i
Next j

For j = 1 To lngFilas
    For i = 1 To lngColumnas
        
        If ablnBacterias(i, j) = True And abacBacterias.Viva = False Then
            
            abacBacterias.Nacer
            RaiseEvent Nacimiento(i, j)
            
        ElseIf ablnBacterias(i, j) = False And abacBacterias.Viva = False Then
        
            abacBacterias.Morir
            RaiseEvent Muerte(i, j)
        End If
    Next i
Next j

Procrear = True

Exit Function

Error:
    
    lngVecinas = lngVecinas - 1
    Resume Next
    
End Function

Private Sub Class_Terminate()
    
    Destruir

End Sub

