VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form frmBMP 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Abre un mapa de bits-BMP"
   ClientHeight    =   3195
   ClientLeft      =   3060
   ClientTop       =   2280
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   Begin MSComDlg.CommonDialog dlgBMP 
      Left            =   2760
      Top             =   2520
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
   End
   Begin VB.CommandButton cmdAbrirBMP 
      Caption         =   "Abrir Mapa de bits"
      Height          =   495
      Left            =   3360
      TabIndex        =   1
      Top             =   2520
      Width           =   1215
   End
   Begin VB.TextBox txtBMP 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2295
      Left            =   1800
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Text            =   "frmBMP.frx":0000
      Top             =   120
      Width           =   2775
   End
   Begin VB.Image imgBMP 
      Height          =   1935
      Left            =   120
      Stretch         =   -1  'True
      Top             =   0
      Width           =   1575
   End
End
Attribute VB_Name = "frmBMP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'contiene informacin sobre el propio archivo
Private Type CabeceraDelArchivo
    'contiene 2 caracteres BM para comprobar que el archivo
    'contiene un mapa de bits
    strTipo             As String * 2
    'tamao del archivo en bytes
    lngTamao           As Long
    'los dos campos intReservado tienen que contener ceros
    intReservado1       As Long
    intReservado2       As Long
    'indica la posicin de la imagen dentro del archivo.
    'Entre las cabeceras y la imagen hay un hueco .
    lngDesplazamiento   As Long
End Type

'contiene informacin sobre la imagen
Private Type CabeceraDeLaImagen
    'tamao del registro
    lngTamao           As Long
    'ancho de la imagen
    lngAncho            As Long
    'alto de la imagen
    lngAlto             As Long
    'nmero de planos de la imagen
    intPlanos           As Integer
    'nmero de bits por pixel
    intBits             As Integer
    'tipo de compresin utilizada
    lngCompresin       As Long
    'tamao de la imagen en bytes = ancho * alto * num planos
    lngTamaoImagen     As Long
    'resolucin horizontal de la imagen
    lngXPuntosPorMtr    As Long
    'resolucin vertical de la imagen
    lngYPuntosPorMtr    As Long
    'nmero de colores usados
    lngColoresUsados    As Long
    'nmero de colores ms importantes de los usados
    lngColoresImport    As Long
End Type
    
Private Sub cmdAbrirBMP_Click()

On Error GoTo Error

With dlgBMP
    .CancelError = True
    .Filter = "Mapa de bits|*.bmp"
    .Flags = .Flags Or cdlOFNFileMustExist _
             Or cdlOFNHideReadOnly Or cdlOFNLongNames
    .ShowOpen
End With

imgBMP.Picture = LoadPicture(dlgBMP.filename)

Dim strArchivo As String
Dim intArchivo As Integer
Dim caCabeceraArchivo As CabeceraDelArchivo
Dim ciCabeceraImagen As CabeceraDeLaImagen

strArchivo = dlgBMP.filename
Caption = dlgBMP.FileTitle & "- BMP"
intArchivo = FreeFile

Open strArchivo For Binary As intArchivo
Get intArchivo, , caCabeceraArchivo
Get intArchivo, , ciCabeceraImagen
Close intArchivo

Dim str As String
str = "Cabecera del archivo" & vbCrLf
str = str & "--------------------"
str = str & vbCrLf

With caCabeceraArchivo
    str = str & "strTipo          :" & .strTipo & vbCrLf
    str = str & "lngTamao        :" & .lngTamao & vbCrLf
    str = str & "intReservado1    :" & .intReservado1 & vbCrLf
    str = str & "intReservado2    :" & .intReservado2 & vbCrLf
    str = str & "lngDesplazamiento:" & .lngDesplazamiento & vbCrLf
End With

str = str & vbCrLf
str = str & "Cabecera de la imagen" & vbCrLf
str = str & "---------------------"
str = str & vbCrLf

With ciCabeceraImagen
    str = str & "lngTamao       :" & .lngTamao & vbCrLf
    str = str & "lngAncho        :" & .lngAncho & vbCrLf
    str = str & "lngAlto         :" & .lngAlto & vbCrLf
    str = str & "intPlanos       :" & .intPlanos & vbCrLf
    str = str & "intBits         :" & .intBits & vbCrLf
    str = str & "lngCompresin   :" & .lngCompresin & vbCrLf
    str = str & "lngTamao Imagen:" & .lngTamaoImagen & vbCrLf
    str = str & "lngXPuntosPorMtr:" & .lngXPuntosPorMtr & vbCrLf
    str = str & "lngYPuntosPorMtr:" & .lngYPuntosPorMtr & vbCrLf
    str = str & "lngColoresUsados:" & .lngColoresUsados & vbCrLf
    str = str & "lngColoresImport:" & .lngColoresImport & vbCrLf
End With

txtBMP = str
Exit Sub

Error:

End Sub
