VERSION 5.00
Begin VB.Form Form16 
   Caption         =   "Busqueda en base de datos"
   ClientHeight    =   2955
   ClientLeft      =   1695
   ClientTop       =   1935
   ClientWidth     =   4425
   LinkTopic       =   "Form16"
   MaxButton       =   0   'False
   ScaleHeight     =   2955
   ScaleWidth      =   4425
   Begin VB.ComboBox Combo2 
      Height          =   315
      Left            =   1080
      TabIndex        =   8
      Top             =   960
      Width           =   3255
   End
   Begin VB.CommandButton Command3 
      BackColor       =   &H00C0FFFF&
      Caption         =   "Continuar busqueda"
      Height          =   375
      Left            =   2280
      Style           =   1  'Graphical
      TabIndex        =   6
      ToolTipText     =   "Continuar la busqueda de registros"
      Top             =   1920
      Width           =   2055
   End
   Begin VB.CommandButton Command2 
      BackColor       =   &H00C0FFFF&
      Caption         =   "Comenzar busqueda"
      Height          =   375
      Left            =   120
      Style           =   1  'Graphical
      TabIndex        =   5
      ToolTipText     =   "Comenzar la busqueda de registro"
      Top             =   1920
      Width           =   2055
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   1080
      TabIndex        =   4
      Top             =   1440
      Width           =   3255
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      ItemData        =   "Form16.frx":0000
      Left            =   1080
      List            =   "Form16.frx":0002
      TabIndex        =   2
      Top             =   480
      Width           =   3255
   End
   Begin VB.Data Data1 
      Caption         =   "Data1"
      Connect         =   "Access"
      DatabaseName    =   "C:\proyecvb\Basedat.mdb"
      DefaultCursorType=   0  'DefaultCursor
      DefaultType     =   2  'UseODBC
      Exclusive       =   0   'False
      Height          =   345
      Left            =   120
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   1  'Dynaset
      RecordSource    =   "Almacen"
      Top             =   0
      Visible         =   0   'False
      Width           =   1140
   End
   Begin VB.CommandButton Command1 
      BackColor       =   &H00FFC0C0&
      Caption         =   "Salir"
      Height          =   495
      Left            =   120
      Style           =   1  'Graphical
      TabIndex        =   0
      ToolTipText     =   "Salir y volver a la pantalla anterior"
      Top             =   2400
      Width           =   4215
   End
   Begin VB.Label Label3 
      Caption         =   "Campo"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   960
      Width           =   975
   End
   Begin VB.Label Label2 
      Caption         =   "Cadena:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   1440
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Buscar en:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   855
   End
End
Attribute VB_Name = "Form16"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public criterio As String
Public encontrado As Boolean
Function comprobar_entradas()
Dim correcto As Boolean

correcto = True

'Comprueba que se haya indicado la tabla a buscar

If Combo1.Text = "" Then
   MsgBox ("ERROR: No se ha indicado la tabla.")
   correcto = False
End If

'Comprueba que se haya indicado el campo a buscar

If Combo2.Text = "" Then
   MsgBox ("ERROR: No se ha indicado el campo.")
   correcto = False
End If

'Comprueba que se haya indicado la cadena a buscar

If Text1.Text = "" Then
   MsgBox ("ERROR: No se ha indicado la cadena.")
   correcto = False
End If

'Devuelve el estado de comprobaciones

comprobar_entradas = correcto

End Function

Private Sub Combo1_Click()
Dim n As Single

'Selecciona la tabla en el recordsource

Data1.RecordSource = Combo1.Text
Data1.Refresh

'Inicializa el Combo2

Combo2.Enabled = True
Combo2.Clear
Combo2.Refresh

'Busca hasta llegar al registro encontrado o hasta el fin de fichero

For n = 0 To Data1.Recordset.Fields.Count - 1 Step 1
    Combo2.AddItem Data1.Recordset.Fields(n).Name
Next n

End Sub

Private Sub Command1_Click()

'Descarga el formulario si no se ha encontrado nada

If Not encontrado Then Unload Form16

'Desactiva la parada en caso de error

On Error Resume Next

'Selecciona el formulario sobre el que se ha buscado

Select Case Combo1.Text

    Case "Almacen"
         Form3.Show
    Case "Clientes"
         Form4.Show
    Case "Compras"
         Form5.Show
    Case "Devoluciones"
         Form6.Show
    Case "Distribuidores"
         Form7.Show
    Case "Ventas"
         Form8.Show

End Select

'No hace nada en caso de error

On Error GoTo 0

'Guarda el campo 0 para poder reposicionar

Form1.aux = Data1.Recordset.Fields(0)

'Descarga el formulario

Unload Form16
    
End Sub

Private Sub Command2_Click()

'Procesa solamente sino hay errores de entrada

If comprobar_entradas Then

   'Va al primer registro

   Data1.Recordset.MoveFirst
   
   'establece el criterio de busqueda

   criterio = Combo2.Text & "=""" & Text1.Text & """"

   'Busca el primer registro que cumpla el criterio

   Data1.Recordset.FindFirst criterio

   'Acciones en caso de encontrar o no encontrar

   If Data1.Recordset.NoMatch Then
   
      'Indica que no ha encontrado nada y establece la variable encontrado
   
      MsgBox ("No se ha encontrado nada.")
      Data1.Recordset.MoveFirst
      encontrado = False
      
   Else
       
       'Establece la variable encontrado
   
       encontrado = True
       
   End If

End If

End Sub

Private Sub Command3_Click()

'Actua solo si no hay errores de entrada

If comprobar_entradas Then

   'Busca el primer registro que cumpla el criterio de busqueda

   Data1.Recordset.FindFirst criterio

   'Muestra el cuadro en caso de que no encuentre nada

   If Data1.Recordset.NoMatch Then
      MsgBox ("No se ha encontrado nada.")
      Data1.Recordset.MoveFirst
   End If
   
End If

End Sub

Private Sub Form_Load()
Dim n As Single

'Establece las distintas tablas de la base de datos

Combo1.AddItem "Almacen"
Combo1.AddItem "Clientes"
Combo1.AddItem "Compras"
Combo1.AddItem "Devoluciones"
Combo1.AddItem "Distribuidores"
Combo1.AddItem "Ventas"

'Establece la tabla sobre la que se busca

Combo1.Text = Form1.tabla

Data1.RecordSource = Combo1.Text
Data1.Refresh

'Inicializa el Combo2

Combo2.Enabled = True
Combo2.Clear
Combo2.Refresh

'Aade elementos al combo2

For n = 0 To Data1.Recordset.Fields.Count - 1 Step 1
    Combo2.AddItem Data1.Recordset.Fields(n).Name
Next n

'Selecciona el elemento adecuado del Combo2

Combo2.Text = Data1.Recordset.Fields(0).Name

End Sub

